#ifndef rsm_protocol_h
#define rsm_protocol_h

#include "rpc.h"


class rsm_client_protocol {
 public:
  enum xxstatus { OK, ERR, NOTMASTER, BUSY};
  typedef int status;
  enum rpc_numbers {
    invoke = 0x9001,
    members,
  };
};

class rsm_protocol {
 public:
  enum xxstatus { OK, ERR, BUSY};
  typedef int status;
  enum rpc_numbers {
    invoke = 0x10001,
    transferreq,
    viewstampreq,
  };
};

struct viewstamp {
  viewstamp (unsigned int _vid = 0, unsigned int _seqno = 0) {
    vid = _vid;
    seqno = _seqno;
  };
  unsigned int vid;
  unsigned int seqno;
};

inline bool operator==(viewstamp a, viewstamp b) {
  return a.vid == b.vid && a.seqno == b.seqno;
}

inline bool operator>(viewstamp a, viewstamp b) {
  return (a.vid > b.vid) || ((a.vid == b.vid) && a.seqno > b.seqno);
}

inline bool operator!=(viewstamp a, viewstamp b) {
  return a.vid != b.vid || a.seqno != b.seqno;
}

inline marshall& operator<<(marshall &m, viewstamp v)
{
  m << v.vid;
  m << v.seqno;
  return m;
}

inline unmarshall& operator>>(unmarshall &u, viewstamp &v) {
  u >> v.vid;
  u >> v.seqno;
  return u;
}
#endif 
